package com.work.provide_tool.apppri.dataro

import androidx.room.Database
import androidx.room.Room
import androidx.room.RoomDatabase
import com.work.provide_tool.app.IApp.Companion.app
import com.work.provide_tool.apppri.dataro.dao.FriendDao
import com.work.provide_tool.apppri.dataro.dao.InterflowDao
import com.work.provide_tool.apppri.dataro.entity.FriendEntity
import com.work.provide_tool.apppri.dataro.entity.InterflowEntity

@Database(
    entities = [FriendEntity::class,InterflowEntity::class],
    version = 1,
    exportSchema = false
)
//@TypeConverters(value = [TypeConverterData::class])
abstract class TalkDb :RoomDatabase(){
    abstract fun getFriendDao(): FriendDao
    abstract fun getInterflowDao(): InterflowDao
//    abstract fun getNotePVPDao():NotePVPDao

    companion object{
        private var talkDb: TalkDb? = null
        fun get(): TalkDb {
            if(talkDb == null){
                synchronized(TalkDb::class.java){
                    if(null == talkDb){
                        talkDb = Room.databaseBuilder(app, TalkDb::class.java,"talk_info_data")
                            .build()
                    }
                }
            }
            return talkDb!!
        }

    }
}