package com.work.provide_tool.apppri.dataro.dao

import androidx.paging.PagingSource
import androidx.room.Dao
import androidx.room.Delete
import androidx.room.Insert
import androidx.room.Query
import androidx.room.Update
import com.work.provide_tool.apppri.dataro.entity.FriendEntity

@Dao
interface FriendDao {
    @Insert
    fun insertFriendData(notePVPDataEntity: FriendEntity)

    @Update
    fun updateFriendData(vararg notePVPDataEntity: FriendEntity)

    @Query("SELECT * FROM friend order by fId")
    fun queryFriendData(): PagingSource<Int, FriendEntity>

    @Query("SELECT * FROM friend where id=:rId order by fId")
    fun queryFriendDataWithLt(rId:Long):List<FriendEntity>?

    @Delete
    fun delFriendData(notePVPDataEntity: FriendEntity)

    @Insert
    fun insertAll(vararg notePVPDataEntity: FriendEntity)

}