package com.work.provide_tool.apppri.dataro.dao

import androidx.paging.PagingSource
import androidx.room.Dao
import androidx.room.Delete
import androidx.room.Insert
import androidx.room.Query
import androidx.room.Update
import com.work.provide_tool.apppri.dataro.entity.FriendEntity
import com.work.provide_tool.apppri.dataro.entity.InterflowEntity

@Dao
interface InterflowDao {
    @Insert
    fun insertInterflowData(notePVPDataEntity: InterflowEntity)

    @Update
    fun updateInterflowData(vararg notePVPDataEntity: InterflowEntity)

    @Query("SELECT * FROM interflow order by interId")
    fun queryInterflowData(): PagingSource<Int, InterflowEntity>

    @Query("SELECT * FROM interflow where id=:rId order by interId")
    fun queryInterflowDataWithLt(rId:Long):List<InterflowEntity>?

    @Delete
    fun delInterflowData(notePVPDataEntity: InterflowEntity)

    @Insert
    fun insertAll(vararg notePVPDataEntity: InterflowEntity)

}