package com.juling.widget_enter

import android.annotation.SuppressLint
import android.app.Activity
import android.os.Bundle
import android.os.Handler
import android.os.Message
import androidx.appcompat.app.AppCompatActivity
import androidx.databinding.DataBindingUtil
import com.alibaba.android.arouter.launcher.ARouter
import com.juling.widget_enter.databinding.ActivityEnterStartBinding
import com.work.provide_tool.general.RouterPath
import com.work.provide_tool.util.onViewEvent

class StartActivity: AppCompatActivity(){
    private val dataBinding by lazy {
        DataBindingUtil.setContentView<ActivityEnterStartBinding>(this,R.layout.activity_enter_start)
    }
    private var total:Int = 3
    private var handler:Handler? =
        @SuppressLint("HandlerLeak")
        object: Handler(){
            override fun handleMessage(mg: Message) {
                dataBinding.textView3.text = "enter $total"
                if(total <= 0){
                    enter()
                    return
                }
                total--
                sendEmptyMessageDelayed(1,1000)
            }
        }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        initDt()
        initV()
        initEvent()

    }

    private fun initDt(){
        handler?.sendEmptyMessage(1)
    }

    private fun initV(){
    }

    private fun initEvent(){
        onViewEvent({v->
            enter()
        },dataBinding.textView6)}

    private fun enter(){
        ARouter.getInstance()
            .build(RouterPath.IPAGE_MAINACTIVITY)
            .navigation()
        freeHandler()
        finish()
    }

    private fun freeHandler(){
        handler?.removeCallbacksAndMessages(null)
        total = 3
    }

    override fun onDestroy() {
        super.onDestroy()
        freeHandler()
    }
}