package com.juling.work_onepage.adapter

import android.content.Context
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.DiffUtil
import com.juling.work_onepage.R
import com.juling.work_onepage.databinding.WidgetInterflowAtBinding
import com.juling.work_onepage.databinding.WidgetInterflowBinding
import com.juling.work_onepage.databinding.WidgetInterflowDrawBinding
import com.juling.work_onepage.databinding.WidgetInterflowDrawWithUBinding
import com.juling.work_onepage.databinding.WidgetInterflowWordBinding
import com.juling.work_onepage.databinding.WidgetInterflowWordWithUBinding
import com.work.provide_origin.origin.GeneralPagingAdapter
import com.work.provide_tool.app.IApp.Companion.app
import com.work.provide_tool.app.IApp.Companion.widthAppDesgin
import com.work.provide_tool.apppri.dataro.entity.InterflowEntity
import com.work.provide_tool.util.dp2Px
import com.work.provide_tool.util.glideLoadRound

class InterflowAdapter(context: Context) :GeneralPagingAdapter<InterflowEntity,WidgetInterflowBinding>(context,object :DiffUtil.ItemCallback<InterflowEntity>(){
    override fun areItemsTheSame(oldItem: InterflowEntity, newItem: InterflowEntity): Boolean {
        return false
    }

    override fun areContentsTheSame(oldItem: InterflowEntity, newItem: InterflowEntity): Boolean {
        return false
    }

}){
    private var type2Layout = HashMap<Int,Int>().apply {
        put(0,R.layout.widget_interflow_word)
        put(1,R.layout.widget_interflow_draw)
        put(2,R.layout.widget_interflow_at)
        put(3,R.layout.widget_interflow_word_with_u)
        put(3+1,R.layout.widget_interflow_draw_with_u)
    }

    override var layout: Int
        get() = R.layout.widget_interflow
        set(value) {}

    override fun onBindViewHolderWork(
        holder: Holder<WidgetInterflowBinding>,
        t: InterflowEntity?,
        position: Int
    ) {
        holder.rootViewType?.run {
            valueLayout.addView(provideView(position% type2Layout.size).apply {
                layoutParams = ViewGroup.LayoutParams(dp2Px(app,widthAppDesgin-30f),ViewGroup.LayoutParams.WRAP_CONTENT)
            })
        }
    }

    private fun provideView(type:Int):View{
        return LayoutInflater.from(context).inflate(type2Layout[type]!!,null).also {view->
            when(type){
                0->initInterFlowWord(DataBindingUtil.bind(view))
                1->initInterFlowDraw(DataBindingUtil.bind(view))
                2->initInterFlowAt(DataBindingUtil.bind(view))
                3->initInterFlowWordWithU(DataBindingUtil.bind(view))
                3+1->initInterFlowDrawWithU(DataBindingUtil.bind(view))
            }
        }
    }

    private fun  initInterFlowWord(widgetInterflowBinding:WidgetInterflowWordBinding?){
        widgetInterflowBinding?.run {
            wordTv.text = "hello啊hello啊hello啊hello啊hello啊hello啊"
            glideLoadRound(R.mipmap.t1,friIg)
        }
    }

    private fun initInterFlowDraw(widgetInterflowDrawBinding:WidgetInterflowDrawBinding?){

    }

    private fun initInterFlowAt(widgetInterflowDrawBinding:WidgetInterflowAtBinding?){

    }

    private fun  initInterFlowWordWithU(widgetInterflowBinding: WidgetInterflowWordWithUBinding?){
        widgetInterflowBinding?.run {
            wordTv.text = "hello啊hello啊hello啊hello啊hello啊hello啊"
            glideLoadRound(R.mipmap.t1,friIg)
        }
    }

    private fun initInterFlowDrawWithU(widgetInterflowDrawBinding: WidgetInterflowDrawWithUBinding?){

    }
}