package com.juling.work_onepage.ui

import android.content.Intent
import android.graphics.Rect
import android.os.Handler
import android.os.Looper
import android.util.Log
import android.view.KeyEvent
import android.view.View
import android.view.Window
import androidx.lifecycle.ViewModelProvider
import androidx.recyclerview.widget.LinearLayoutManager
import com.juling.work_onepage.R
import com.juling.work_onepage.adapter.InterflowAdapter
import com.juling.work_onepage.databinding.ActivityInterflowBinding
import com.juling.work_onepage.util.TURN_UI_INFO_WITH_FRIEND_ENTITY
import com.juling.work_onepage.work.FriendViewModel
import com.juling.work_onepage.work.InterflowViewModel
import com.work.provide_origin.origin.GeneralAgentActivity
import com.work.provide_tool.apppri.dataro.TalkDb
import com.work.provide_tool.apppri.dataro.entity.FriendEntity
import com.work.provide_tool.apppri.dataro.entity.InterflowEntity
import com.work.provide_tool.util.AppActivityLeader
import com.work.provide_tool.util.keepDataUpdateWithUi

class InterflowActivity:GeneralAgentActivity<InterflowViewModel,ActivityInterflowBinding>() {
    private var friendEntity:FriendEntity? = null
    private lateinit var interflowAdapter:InterflowAdapter
    private val iViewModel by lazy {
        ViewModelProvider(this)[InterflowViewModel::class.java]
    }
    private var initRv = false

    companion object{
        fun start(friendEntity:FriendEntity?){
            AppActivityLeader.getActivity()?.run {
                startActivity(Intent(this,InterflowActivity::class.java)
                    .putExtra(TURN_UI_INFO_WITH_FRIEND_ENTITY,friendEntity))
            }
        }
    }

    override var layout: Int
        get() = R.layout.activity_interflow
        set(value) {}

    protected override fun initDo(){
        friendEntity = intent.getParcelableExtra(TURN_UI_INFO_WITH_FRIEND_ENTITY)
    }

    override fun createLooker() {
        iViewModel.getInterflowList().observe(this){dt->
            keepDataUpdateWithUi(this,{
                interflowAdapter.submitData(dt)
            })
        }
    }

    override fun initTitle(titleView: View) {
        super.initTitle(titleView)
        getLeftView().visibility = View.GONE
        setTitleNa("好友！")
        getTitleView().setOnClickListener {
            keepDataUpdateWithUi(this,{
                TalkDb.get().getInterflowDao().insertInterflowData(InterflowEntity(1,"hello"))
            })
        }
    }

    override fun initUi() {
        initRv()
    }

    private fun initRv(){
        iDataBinding.recyclerView.run {
            adapter = InterflowAdapter(activity).apply {
                interflowAdapter = this
            }
            layoutManager = LinearLayoutManager(activity)

        }
    }

    override fun initData() {
        iDataBinding.talkInputWidget.setTalkLayoutWithInputListen { value->
            Handler(Looper.getMainLooper()).postDelayed({
                rv2End()
            },50)
        }
    }

    override fun onWindowFocusChanged(hasFocus: Boolean) {
        super.onWindowFocusChanged(hasFocus)
        if(!initRv){
            rv2End()
            initRv = true
        }
    }


    override fun initEvent() {
    }

    private fun rv2End(){
        iDataBinding.recyclerView .scrollToPosition(interflowAdapter.itemCount-1)
    }

    override fun onKeyDown(keyCode: Int, event: KeyEvent?): Boolean {
        if(keyCode == KeyEvent.KEYCODE_BACK){
            var talkInputWidget = iDataBinding.talkInputWidget
            if(!talkInputWidget.getFunTagWithInit()){
                talkInputWidget.restoreKeyInput()
                return true
            }
        }
        return super.onKeyDown(keyCode, event)
    }

}