package com.juling.work_onepage.util.widget

import android.app.Activity
import android.content.Context
import android.os.Handler
import android.os.Looper
import android.util.AttributeSet
import android.util.Log
import android.view.KeyEvent
import android.view.LayoutInflater
import android.view.View
import android.view.inputmethod.EditorInfo
import android.widget.EditText
import android.widget.ImageView
import android.widget.LinearLayout
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.juling.work_onepage.R
import com.work.provide_tool.util.HIDE
import com.work.provide_tool.util.SHOW
import com.work.provide_tool.util.ToastUtil
import com.work.provide_tool.util.addListener
import com.work.provide_tool.util.getInputKey
import com.work.provide_tool.util.hideInputKey
import com.work.provide_tool.util.showInputKey
import com.work.provide_tool.util.showLayoutType

class TalkInputWidget(context: Context?, attrs: AttributeSet?) :
    LinearLayout(context, attrs) {

    private lateinit var iv_feel: ImageView
    private lateinit var iv_add: ImageView
    private lateinit var rv:RecyclerView
    private lateinit var layout_feel: View
    private lateinit var rv_add:RecyclerView
    private lateinit var layout_add:View

    private var dataAdd:ArrayList<TalkTypeDataWithAdd> = ArrayList()
    private var dataFel:ArrayList<TalkTypeDataWithFeel> = ArrayList()
    private lateinit var et:EditText
    private var handler = Handler(Looper.getMainLooper())
    private lateinit var a:Activity
    private var adjustTalkLayoutWithInput:((Int)->Unit)? = null

    private var addInfoWordArr = arrayOf("图片","拍摄","文件","位置")

    companion object{
        var FUN_INIT = 0
        var FUN_ADD = 1
        var FUN_FEEL = 2
    }

    init {
        LayoutInflater.from(context).inflate(R.layout.widget_talk_input
            ,this,true)
        a = context as Activity
        initAll()
    }

    private fun initAll(){
        initV()
        initEvent()
    }

    private fun initV(){
        getView()
        initRv()
        initRvAdd()
    }

    private fun getView(){
        rv = findViewById(R.id.rv)
        iv_add = findViewById(R.id.iv_add)
        iv_feel = findViewById(R.id.iv_feel)
        et = findViewById(R.id.et)
        layout_feel = findViewById(R.id.layout_feel)
        rv_add = findViewById(R.id.rv_add)
        layout_add = findViewById(R.id.layout_add)
    }

    private fun initRv(){
        //TODO1
        tt()
        rv.run {
            var unit = 3+1
            layoutManager = GridLayoutManager(context,unit)
            adapter = object:BaseQuickAdapter<TalkTypeDataWithFeel,BaseViewHolder>(R.layout.widget_talk_input_with_feel,dataFel){
                override fun convert(holder: BaseViewHolder, item: TalkTypeDataWithFeel) {
                    holder.setText(R.id.tv,item.na)
                }
            }

//            addItemDecoration(GridSpacingItemWithDecoration(0))
        }
    }

    private fun initRvAdd(){
        rv_add.run {
            var unit = 3+1
            layoutManager = GridLayoutManager(context,unit)
            adapter = object:BaseQuickAdapter<TalkTypeDataWithAdd,BaseViewHolder>(R.layout.widget_talk_input_with_add,dataAdd){
                override fun convert(holder: BaseViewHolder, item: TalkTypeDataWithAdd) {
                    holder.setText(R.id.tv,item.na)
                }

            }
        }

    }

    private fun tt(){
        for(i in addInfoWordArr.indices){
            dataAdd.add(TalkTypeDataWithAdd(addInfoWordArr[i],1,1))
        }


        for (i in 0..5){
            dataFel.add(TalkTypeDataWithFeel("hello",1,1))
        }
    }


    private fun initEvent(){
        et.setOnEditorActionListener{tv,id,keyEvent->
//            if(id == EditorInfo.IME_ACTION_DONE){
//                true
//
//            }else{
//
//            }
            false
        }

        et.setOnFocusChangeListener{v,have->
            if(have){
                showOnlyKey()
            }
        }


        addListener({v->
            when(v.id){
                R.id.iv_add -> handlerAddIv()
                R.id.iv_feel -> handlerFeelIv()
            }
        },iv_add,iv_feel)
    }

    private fun handlerAddIv(){
        var value = et.text.toString()
        if(value.length > 0){
            ToastUtil.show(value)
            return
        }

        et.clearFocus()
        if(layout_add.visibility != View.VISIBLE){
            showLayoutType(layout_add, SHOW)
            showLayoutType(layout_feel, HIDE)
            if(getInputKey(a)){
                hideInputKey(et)
            }
        }else{
            showLayoutType(layout_add, HIDE)
            showInputKey(et)
        }
        adjustTalkLayoutWithInput?.invoke(0)
    }

    private fun handlerFeelIv(){
        et.clearFocus()
        if(layout_feel.visibility != View.VISIBLE){
            showLayoutType(layout_feel, SHOW)
            showLayoutType(layout_add, HIDE)
            if(getInputKey(a)){
                hideInputKey(et)
            }
        }else{
            showLayoutType(layout_feel, HIDE)
            showInputKey(et)
        }
        adjustTalkLayoutWithInput?.invoke(0)
    }

    fun restoreKeyInput(){
        showLayoutType(layout_feel, HIDE)
        showLayoutType(layout_add, HIDE)
        if(getInputKey(a)){
            hideInputKey(et)
        }
        adjustTalkLayoutWithInput?.invoke(0)
    }

    private fun showOnlyKey(){
        showLayoutType(layout_feel, HIDE)
        showLayoutType(layout_add, HIDE)
        if(!getInputKey(a)){
            showInputKey(et)
        }
        adjustTalkLayoutWithInput?.invoke(0)
    }

    fun getFunTagWithInit(): Boolean {
        return layout_feel.visibility != View.VISIBLE
                && layout_add.visibility != View.VISIBLE
                && !getInputKey(a)
    }

    //调整聊天记录Ui
    fun setTalkLayoutWithInputListen(adjustTalkLayoutWithInput:(Int)->Unit = {}){
        this.adjustTalkLayoutWithInput = adjustTalkLayoutWithInput
    }

}